// ------------------------------------------------------------------------------------
// irr::core::array<S3DVertex> wrappers
// NOTES:
// did not wrap the const version of getLast()
// ------------------------------------------------------------------------------------

extern "C" array<S3DVertex>* IrrCore_Array_S3DVertex_new()
{
	return new array<S3DVertex>();
}

extern "C" array<S3DVertex>* IrrCore_Array_S3DVertex_newWithSize(u32 start_count)
{
	return new array<S3DVertex>(start_count);
}

extern "C" array<S3DVertex>* IrrCore_Array_S3DVertex_newFromOther(array<S3DVertex>* other)
{
	return new array<S3DVertex>(*other);
}

extern "C" void IrrCore_Array_S3DVertex_del(array<S3DVertex>* arr)
{
	if (arr)
		delete arr;
		
	arr=0;
}

extern "C" u32 IrrCore_Array_S3DVertex_allocated_size(array<S3DVertex>* arr)
{
	if (arr)
		return arr->allocated_size();
	else
		return 0;
}

extern "C" void IrrCore_Array_S3DVertex_clear(array<S3DVertex>* arr)
{
	if (arr)
		arr->clear();
}

extern "C" const S3DVertex* IrrCore_Array_S3DVertex_const_pointer(array<S3DVertex>* arr)
{
	if (arr)
		arr->const_pointer();
}

extern "C" S3DVertex* IrrCore_Array_S3DVertex_pointer(array<S3DVertex>* arr)
{
	if (arr)
		arr->pointer();
}

extern "C" bool IrrCore_Array_S3DVertex_empty(array<S3DVertex>* arr)
{
	if (arr)
		return arr->empty();
	else
		return true;
}

extern "C" void IrrCore_Array_S3DVertex_eraseWithCount(array<S3DVertex>* arr,u32 idx,s32 count)
{
	if (arr)
		arr->erase(idx,count);
}

extern "C" void IrrCore_Array_S3DVertex_erase(array<S3DVertex>* arr,u32 idx)
{
	if (arr)
		arr->erase(idx);
}

// do not delete this pointer
extern "C" S3DVertex* IrrCore_Array_S3DVertex_getLast(array<S3DVertex>* arr)
{
	if (arr)
		return &arr->getLast();
	else
		return 0;
}

// do not delete this pointer
extern "C" S3DVertex* IrrCore_Array_S3DVertex_elementAt(array<S3DVertex>* arr,u32 idx)
{
	if (arr)
		return &(*arr)[idx];
	else
		return 0;
}

extern "C" void IrrCore_Array_S3DVertex_insert(array<S3DVertex>* arr,S3DVertex* element,u32 idx=0)
{
	if (arr)
		arr->insert(*element,idx);
}

extern "C" void IrrCore_Array_S3DVertex_Eq(array<S3DVertex>* arr,array<S3DVertex>* other)
{
	if (arr)
		*arr=*other;
}

extern "C" void IrrCore_Array_S3DVertex_push_back(array<S3DVertex>* arr,S3DVertex* element)
{
	if (arr)
		arr->push_back(*element);
}

extern "C" void IrrCore_Array_S3DVertex_push_front(array<S3DVertex>* arr,S3DVertex* element)
{
	if (arr)
		arr->push_front(*element);
}

extern "C" void IrrCore_Array_S3DVertex_reallocate(array<S3DVertex>* arr,u32 new_size)
{
	if (arr)
		arr->reallocate(new_size);
}

extern "C" void IrrCore_Array_S3DVertex_set_free_when_destroyed(array<S3DVertex>* arr,bool f)
{
	if (arr)
		arr->set_free_when_destroyed(f);
}

extern "C" void IrrCore_Array_S3DVertex_set_pointer(array<S3DVertex>* arr,S3DVertex newPointer[],u32 size)
{
	if (arr)
		arr->set_pointer(newPointer,size);
}

extern "C" void IrrCore_Array_S3DVertex_set_sorted(array<S3DVertex>* arr,bool bVal)
{
	if (arr)
		arr->set_sorted(bVal);
}

extern "C" void IrrCore_Array_S3DVertex_set_used(array<S3DVertex>* arr,bool bVal)
{
	if (arr)
		arr->set_used(bVal);
}

extern "C" u32 IrrCore_Array_S3DVertex_size(array<S3DVertex>* arr)
{
	if (arr)
		return arr->size();
	else
		return 0;
}

/*
extern "C" s32 IrrCore_Array_S3DVertex_linear_reverse_search(array<S3DVertex>* arr,S3DVertex* find)
{
	if (arr)
		return arr->linear_reverse_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_S3DVertex_linear_search(array<S3DVertex>* arr,S3DVertex* find)
{
	if (arr)
		return arr->linear_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_S3DVertex_binary_search(array<S3DVertex>* arr,S3DVertex* find)
{
	if (arr)
		return arr->binary_search(*find);
	else
		return -1;
}



extern "C" s32 IrrCore_Array_S3DVertex_binary_searchWithBounds(array<S3DVertex>* arr,S3DVertex* find,s32 left,s32 right)
{
	if (arr)
		return arr->binary_search(*find,left,right);
	else
		return -1;
}

extern "C" void IrrCore_Array_S3DVertex_sort(array<S3DVertex>* arr)
{
	if (arr)
		arr->sort();
}
*/


